unit movemake;

interface

uses param, attack, hash,util;

function makemove(move:integer;ply:byte):boolean;
function makemove_q(move:integer;ply:byte):boolean;
function makemove_simple(move:integer;ply:byte):boolean;
procedure unmakemove(move:integer;ply:byte);

implementation

function makemove(move:integer;ply:byte):boolean;
var mf,mt,mk,mp,pp:byte;
    boardkey:int64;
    pawnkey:integer;
begin
  tree[ply+1].enpass:=255; tree[ply+1].castles:=tree[ply].castles;
  tree[ply+1].matw:=tree[ply].matw;
  tree[ply+1].matb:=tree[ply].matb;
  tree[ply+1].wking:=tree[ply].wking;
  tree[ply+1].wqueen:=tree[ply].wqueen;
  tree[ply+1].bking:=tree[ply].bking;
  tree[ply+1].bqueen:=tree[ply].bqueen;
  tree[ply+1].tomove:=1-tree[ply].tomove;
  tree[ply+1].lastmove:=move;
  boardkey:=tree[ply].boardkey;
  pawnkey:=tree[ply].pawnkey;
  mf:=move and 255;
  mt:=(move shr 8) and 255;
  mk:=(move shr 16) and 255;
  mp:=(move shr 24) and 255;
  if mp=0 then BoardKey:=BoardKey xor ZorbistTable[WhatPiese(mf),mt];
  BoardKey:=BoardKey xor ZorbistTable[WhatPiese(mf),mf];
  BoardKey:=BoardKey xor ZorbistEnp[tree[ply].enpass];
  BoardKey:=BoardKey xor ZorbistColor;
  if tree[ply].tomove=0 then
  begin
    if mk<>0 then
    begin
      pp:=WhatPiese(mt);
      if pp=0 then BoardKey:=BoardKey xor ZorbistTable[WhatPiese(tree[ply].enpass-16),tree[ply].enpass-16]
      else
      begin
        BoardKey:=BoardKey xor ZorbistTable[pp,mt];
        if pp=12 then pawnkey:=pawnkey xor Zorbist32[2,mt];
      end;
    end;
    if (board[mf] and 7)=1 then
    begin
      if (mf=4) and (mt=6) then
      begin
        BoardKey:=BoardKey xor ZorbistTable[WhatPiese(7),7];
        BoardKey:=BoardKey xor ZorbistTable[WhatPiese(7),5];
        board[5]:=board[7];
        board[7]:=0;
      end;
      if (mf=4) and (mt=2) then
      begin
        BoardKey:=BoardKey xor ZorbistTable[WhatPiese(0),0];
        BoardKey:=BoardKey xor ZorbistTable[WhatPiese(0),3];
        board[3]:=board[0];
        board[0]:=0;
      end;
      tree[ply+1].wking:=mt;
      if (tree[ply+1].castles and whiteking)<>0 then BoardKey:=BoardKey xor ZorbistCast[1];
      if (tree[ply+1].castles and whitequeen)<>0 then BoardKey:=BoardKey xor ZorbistCast[2];
      tree[ply+1].castles:=tree[ply+1].castles and 12;
    end;
    if (board[mf] and 7)=2 then tree[ply+1].wqueen:=mt;
    if (board[mf] and 7)=3 then
    begin
      if mf=7 then
      begin
        if (tree[ply+1].castles and whiteking)<>0 then BoardKey:=BoardKey xor ZorbistCast[1];
        tree[ply+1].castles:=tree[ply+1].castles and 14;
      end;
      if mf=0 then
      begin
        if (tree[ply+1].castles and whitequeen)<>0 then BoardKey:=BoardKey xor ZorbistCast[2];
        tree[ply+1].castles:=tree[ply+1].castles and 13;
      end;
    end;
    if (board[mf] and 7)=6 then
    begin
      pawnkey:=pawnkey xor Zorbist32[1,mf];
      if mp=0 then pawnkey:=pawnkey xor Zorbist32[1,mt];
      if mf+32=mt then
      begin
        if board[mt+1]=128+6 then tree[ply+1].enpass:=mf+16;
        if board[mt-1]=128+6 then tree[ply+1].enpass:=mf+16;
      end;
      if (mt=tree[ply].enpass) and (mk<>0) then
      begin
        board[tree[ply].enpass-16]:=0;
        pawnkey:=pawnkey xor Zorbist32[2,tree[ply].enpass-16];
      end;
    end;
    if mk<>0 then
    begin
      dec(tree[ply+1].matb,prices[mk]);
      if mt=tree[ply+1].bqueen then tree[ply+1].bqueen:=255;
    end;
    if mp<>0 then inc(tree[ply+1].matw,prices[mp]-cpawn);
    if mp=0 then Board[mt]:=Board[mf]
    else board[mt]:=mp+64;
  end else
  begin
    if mk<>0 then
    begin
      pp:=WhatPiese(mt);
      if pp=0 then BoardKey:=BoardKey xor ZorbistTable[WhatPiese(tree[ply].enpass+16),tree[ply].enpass+16]
      else
      begin
        if pp=6 then pawnkey:=pawnkey xor Zorbist32[1,mt];
        BoardKey:=BoardKey xor ZorbistTable[pp,mt];
      end;
    end;
    if (board[mf] and 7)=1 then
    begin
      if (mf=116) and (mt=118) then
      begin
        BoardKey:=BoardKey xor ZorbistTable[WhatPiese(119),119];
        BoardKey:=BoardKey xor ZorbistTable[WhatPiese(119),117];
        board[117]:=board[119];
        board[119]:=0;
      end;
      if (mf=116) and (mt=114) then
      begin
        BoardKey:=BoardKey xor ZorbistTable[WhatPiese(112),112];
        BoardKey:=BoardKey xor ZorbistTable[WhatPiese(112),115];
        board[115]:=board[112];
        board[112]:=0;
      end;
      tree[ply+1].bking:=mt;
      if (tree[ply+1].castles and blackking)<>0 then BoardKey:=BoardKey xor ZorbistCast[3];
      if (tree[ply+1].castles and blackqueen)<>0 then BoardKey:=BoardKey xor ZorbistCast[4];
      tree[ply+1].castles:=tree[ply+1].castles and 3;
    end;
    if (board[mf] and 7)=2 then tree[ply+1].bqueen:=mt;
    if (board[mf] and 7)=3 then
    begin
      if mf=119 then
      begin
        if (tree[ply+1].castles and blackking)<>0 then BoardKey:=BoardKey xor ZorbistCast[3];
        tree[ply+1].castles:=tree[ply+1].castles and 11;
      end;
      if mf=112 then
      begin
        if (tree[ply+1].castles and blackqueen)<>0 then BoardKey:=BoardKey xor ZorbistCast[4];
        tree[ply+1].castles:=tree[ply+1].castles and 7;
      end;
    end;
    if (board[mf] and 7)=6 then
    begin
      pawnkey:=pawnkey xor Zorbist32[2,mf];
      if mp=0 then pawnkey:=pawnkey xor Zorbist32[2,mt];
      if mf-32=mt then
      begin
        if board[mt+1]=64+6 then tree[ply+1].enpass:=mf-16;
        if board[mt-1]=64+6 then tree[ply+1].enpass:=mf-16;
      end;
      if (mt=tree[ply].enpass) and (mk<>0) then
      begin
        pawnkey:=pawnkey xor Zorbist32[1,tree[ply].enpass+16];
        board[tree[ply].enpass+16]:=0;
      end;
    end;
    if mk<>0 then
    begin
      dec(tree[ply+1].matw,prices[mk]);
      if mt=tree[ply+1].wqueen then tree[ply+1].wqueen:=255;
    end;
    if mp<>0 then inc(tree[ply+1].matb,prices[mp]-cpawn);
    if mp=0 then Board[mt]:=Board[mf]
    else board[mt]:=mp+128;
  end;
  Board[mf]:=0; result:=true;
  if mp<>0 then BoardKey:=BoardKey xor ZorbistTable[WhatPiese(mt),mt];
  tree[ply+1].boardkey:=BoardKey xor ZorbistEnp[tree[ply+1].enpass];
  tree[ply+1].pawnkey:=pawnkey;

  if attacked(tree[ply].tomove,ply+1,255) then
  begin
    unmakemove(move,ply);
    result:=false;
  end;
end;

function makemove_q(move:integer;ply:byte):boolean;
var mf,mt,mk,mp,pp:byte;
    pawnkey:integer;
begin
  tree[ply+1].enpass:=255;
  tree[ply+1].matw:=tree[ply].matw;
  tree[ply+1].matb:=tree[ply].matb;
  tree[ply+1].wking:=tree[ply].wking;
  tree[ply+1].wqueen:=tree[ply].wqueen;
  tree[ply+1].bking:=tree[ply].bking;
  tree[ply+1].bqueen:=tree[ply].bqueen;
  tree[ply+1].tomove:=1-tree[ply].tomove;
  pawnkey:=tree[ply].pawnkey;
  mf:=move and 255;
  mt:=(move shr 8) and 255;
  mk:=(move shr 16) and 255;
  mp:=(move shr 24) and 255;
  if tree[ply].tomove=0 then
  begin
    if mk<>0 then
    begin
      pp:=WhatPiese(mt);
      if pp=12 then pawnkey:=pawnkey xor Zorbist32[2,mt];
    end;
    if (board[mf] and 7)=1 then
    begin
      if (mf=4) and (mt=6) then
      begin
        board[5]:=board[7];
        board[7]:=0;
      end;
      if (mf=4) and (mt=2) then
      begin
        board[3]:=board[0];
        board[0]:=0;
      end;
      tree[ply+1].wking:=mt;
    end;
    if (board[mf] and 7)=2 then tree[ply+1].wqueen:=mt;
    if (board[mf] and 7)=6 then
    begin
      pawnkey:=pawnkey xor Zorbist32[1,mf];
      if mp=0 then pawnkey:=pawnkey xor Zorbist32[1,mt];
      if (mt=tree[ply].enpass) and (mk<>0) then
      begin
        board[tree[ply].enpass-16]:=0;
        pawnkey:=pawnkey xor Zorbist32[2,tree[ply].enpass-16];
      end;
    end;
    if mk<>0 then
    begin
      dec(tree[ply+1].matb,prices[mk]);
      if mt=tree[ply+1].bqueen then tree[ply+1].bqueen:=255;
    end;
    if mp<>0 then inc(tree[ply+1].matw,prices[mp]-cpawn);
    if mp=0 then Board[mt]:=Board[mf]
    else board[mt]:=mp+64;
  end else
  begin
    if mk<>0 then
    begin
      pp:=WhatPiese(mt);
      if pp=6 then pawnkey:=pawnkey xor Zorbist32[1,mt];
    end;
    if (board[mf] and 7)=1 then
    begin
      if (mf=116) and (mt=118) then
      begin
        board[117]:=board[119];
        board[119]:=0;
      end;
      if (mf=116) and (mt=114) then
      begin
        board[115]:=board[112];
        board[112]:=0;
      end;
      tree[ply+1].bking:=mt;
    end;
    if (board[mf] and 7)=2 then tree[ply+1].bqueen:=mt;
    if (board[mf] and 7)=6 then
    begin
      pawnkey:=pawnkey xor Zorbist32[2,mf];
      if mp=0 then pawnkey:=pawnkey xor Zorbist32[2,mt];
      if (mt=tree[ply].enpass) and (mk<>0) then
      begin
        pawnkey:=pawnkey xor Zorbist32[1,tree[ply].enpass+16];
        board[tree[ply].enpass+16]:=0;
      end;
    end;
    if mk<>0 then
    begin
      dec(tree[ply+1].matw,prices[mk]);
      if mt=tree[ply+1].wqueen then tree[ply+1].wqueen:=255;
    end;
    if mp<>0 then inc(tree[ply+1].matb,prices[mp]-cpawn);
    if mp=0 then Board[mt]:=Board[mf]
    else board[mt]:=mp+128;
  end;
  Board[mf]:=0; result:=true;
  tree[ply+1].pawnkey:=pawnkey;

  if attacked(tree[ply].tomove,ply+1,255) then
  begin
    unmakemove(move,ply);
    result:=false;
  end;
end;

function makemove_simple(move:integer;ply:byte):boolean;
var mf,mt,mk,mp:byte;
begin
  tree[ply+1].wking:=tree[ply].wking;
  tree[ply+1].bking:=tree[ply].bking;
  tree[ply+1].tomove:=1-tree[ply].tomove;
  mf:=move and 255;
  mt:=(move shr 8) and 255;
  mk:=(move shr 16) and 255;
  mp:=(move shr 24) and 255;
  if tree[ply].tomove=0 then
  begin
    if (board[mf] and 7)=1 then
    begin
      if (mf=4) and (mt=6) then
      begin
        board[5]:=board[7];
        board[7]:=0;
      end;
      if (mf=4) and (mt=2) then
      begin
        board[3]:=board[0];
        board[0]:=0;
      end;
      tree[ply+1].wking:=mt;
    end;
    if (board[mf] and 7)=6 then
    begin
      if (mt=tree[ply].enpass) and (mk<>0) then
      begin
        board[tree[ply].enpass-16]:=0;
      end;
    end;
    if mp=0 then Board[mt]:=Board[mf]
    else board[mt]:=mp+64;
  end else
  begin
    if (board[mf] and 7)=1 then
    begin
      if (mf=116) and (mt=118) then
      begin
        board[117]:=board[119];
        board[119]:=0;
      end;
      if (mf=116) and (mt=114) then
      begin
        board[115]:=board[112];
        board[112]:=0;
      end;
      tree[ply+1].bking:=mt;
    end;
    if (board[mf] and 7)=6 then
    begin
      if (mt=tree[ply].enpass) and (mk<>0) then
      begin
        board[tree[ply].enpass+16]:=0;
      end;
    end;
    if mp=0 then Board[mt]:=Board[mf]
    else board[mt]:=mp+128;
  end;
  Board[mf]:=0; result:=true;
  if attacked(tree[ply].tomove,ply+1,255) then
  begin
    unmakemove(move,ply);
    result:=false;
  end;
end;

procedure unmakemove(move:integer;ply:byte);
var mf,mt,mk,mp:byte;
begin
  mf:=move and 255;
  mt:=(move shr 8) and 255;
  mk:=(move shr 16) and 255;
  mp:=(move shr 24) and 255;
  if tree[ply].tomove=0 then
  begin
    if (board[mt] and 7)=1 then
    begin
      if (mf=4) and (mt=6) then
      begin
        board[7]:=board[5];
        board[5]:=0;
      end;
      if (mf=4) and (mt=2) then
      begin
        board[0]:=board[3];
        board[3]:=0;
      end;
    end;
    if (board[mt] and 7)=6 then
      if (mt=tree[ply].enpass) and (mk<>0) then
      begin
        board[tree[ply].enpass-16]:=128+6;
        mk:=0;
      end;
    if mp=0 then board[mf]:=board[mt]
    else board[mf]:=64+6;
    if mk=0 then board[mt]:=0
    else board[mt]:=mk+128;
  end else
  begin
    if (board[mt] and 7)=1 then
    begin
      if (mf=116) and (mt=118) then
      begin
        board[119]:=board[117];
        board[117]:=0;
      end;
      if (mf=116) and (mt=114) then
      begin
        board[112]:=board[115];
        board[115]:=0;
      end;
    end;
    if (board[mt] and 7)=6 then
      if (mt=tree[ply].enpass) and (mk<>0) then
      begin
        board[tree[ply].enpass+16]:=64+6;
        mk:=0;
      end;
    if mp=0 then board[mf]:=board[mt]
    else board[mf]:=128+6;
    if mk=0 then board[mt]:=0
    else board[mt]:=mk+64;
  end;   
end;

end.
