unit sortmoves;

interface

uses param, movemake, hash, util;


var history,histhit,histtot:array[1..12*128] of integer;
    killers:array[1..maxply,1..2] of integer;

procedure SortLegal(ply:byte);
procedure SortInit(ply:byte);
procedure RootSort;
procedure HistoryInit;
procedure GoodMove(move:integer;ply,depth:byte);
procedure HistoryGood(move:integer);
procedure HistoryBad(move:integer);
procedure PVToHash(score:integer;depth:byte;lin:TLine);

implementation

procedure SortLegal(ply:byte);
var i,j,k,f,t,mo:integer;
    tm1,tm2:integer;
    p,c:byte;
begin
  f:=ply*300+1; t:=ply*300+tree[ply].movenum;
  k:=0;
  for i:=f to t do
  begin
    sortm[1,i]:=i;
    mo:=moves[i];
    if makemove_simple(mo,ply) then
    begin
      inc(k);
      unmakemove(mo,ply);
      if mo=tree[ply].hmove then sortm[2,i]:=32768+16384
      else if (mo shr 16)<>0 then
      begin
        p:=board[mo and 255] and 7;
        c:=(mo shr 16) and 255;
        sortm[2,i]:=32768+p-c+16-(mo shr 24);
      end else
      begin
        if mo=killers[ply,1] then sortm[2,i]:=16384+200
        else if mo=killers[ply,2] then sortm[2,i]:=16384+100
        else
        begin
          j:=board[mo and 255] and 7;
          if (board[mo and 255] and 128)<>0 then inc(j,6);
          j:=j+12*((mo shr 8) and 255);
          sortm[2,i]:=(histhit[j]*16384) div histtot[j];
        end;
      end;
    end else sortm[2,i]:=-128;
  end;

  sortm[2,t+1]:=-32768;
  for i:=t-1 downto f do
  begin
    tm1:=sortm[1,i];
    tm2:=sortm[2,i];
    j:=i;
    while tm2<sortm[2,j+1] do
    begin
      sortm[1,j]:=sortm[1,j+1];
      sortm[2,j]:=sortm[2,j+1];
      inc(j);
    end;
    sortm[1,j]:=tm1;
    sortm[2,j]:=tm2;
  end;

  tree[ply].movenum:=k;
end;

procedure SortInit(ply:byte);
var i,j,f,t,mo:integer;
    tm1,tm2:integer;
    p,c:byte;
begin
  f:=ply*300+1; t:=ply*300+tree[ply].movenum;
  for i:=f to t do
  begin
    sortm[1,i]:=i;
    mo:=moves[i];
    if mo=tree[ply].hmove then sortm[2,i]:=32768+16384
    else if (mo shr 16)<>0 then
    begin
      p:=7-(board[mo and 255] and 7);
      c:=7-((mo shr 16) and 255);
      sortm[2,i]:=32768+10*c-p+16-(mo shr 24);
//      sortm[2,i]:=32768+SeeMove(mo,ply);
    end else
    begin
      sortm[2,i]:=0;
      if mo=killers[ply,1] then sortm[2,i]:=16384+200
      else if mo=killers[ply,2] then sortm[2,i]:=16384+100
      else
      begin
        j:=board[mo and 255] and 7;
        if (board[mo and 255] and 128)<>0 then inc(j,6);
        j:=j+12*((mo shr 8) and 255);
        sortm[2,i]:=(histhit[j]*16384) div histtot[j];
      end;
    end;
  end;

  sortm[2,t+1]:=-32768;
  for i:=t-1 downto f do
  begin
    tm1:=sortm[1,i];
    tm2:=sortm[2,i];
    j:=i;
    while tm2<sortm[2,j+1] do
    begin
      sortm[1,j]:=sortm[1,j+1];
      sortm[2,j]:=sortm[2,j+1];
      inc(j);
    end;
    sortm[1,j]:=tm1;
    sortm[2,j]:=tm2;
  end;
end;

procedure RootSort;
var i,j,tmp:integer;
begin
  for i:=1 to tree[0].movenum-1  do
    for j:=i+1 to tree[0].movenum do
      if sortroot[2,i]<sortroot[2,j] then
      begin
        tmp:=sortroot[1,i];
        sortroot[1,i]:=sortroot[1,j];
        sortroot[1,j]:=tmp;
        tmp:=sortroot[2,i];
        sortroot[2,i]:=sortroot[2,j];
        sortroot[2,j]:=tmp;
      end;
end;

procedure HistoryInit;
var i:integer;
begin
  for i:=1 to maxply do
  begin
    killers[i,1]:=0;
    killers[i,2]:=0;
  end;
  for i:=1 to 12*128 do
  begin
    histhit[i]:=1;
    histtot[i]:=1;
    history[i]:=0;
  end;
end;

procedure GoodMove(move:integer;ply,depth:byte);
var ind,i:integer;
begin
  if (move shr 16)<>0 then exit;
  if killers[ply,1]<>move then
  begin
    killers[ply,2]:=killers[ply,1];
    killers[ply,1]:=move;
  end;
  ind:=board[move and 255] and 7;
  if (board[move and 255] and 128)<>0 then inc(ind,6);
  ind:=ind+12*((move shr 8) and 255);
  inc(history[ind], depth*depth);
  if history[ind]>=16384 then
    for i:=1 to 12*64 do
      history[i]:=(history[i]+1) div 2;
end;

procedure HistoryGood(move:integer);
var ind:integer;
begin
  if (move shr 16)<>0 then exit;
  ind:=board[move and 255] and 7;
  if (board[move and 255] and 128)<>0 then inc(ind,6);
  ind:=ind+12*((move shr 8) and 255);
  inc(histhit[ind]);
  inc(histtot[ind]);
  if histtot[ind]>=16384 then
  begin
    histtot[ind]:=(histtot[ind]+1) div 2;
    histhit[ind]:=(histhit[ind]+1) div 2;
  end;
end;

procedure HistoryBad(move:integer);
var ind:integer;
begin
  if (move shr 16)<>0 then exit;
  ind:=board[move and 255] and 7;
  if (board[move and 255] and 128)<>0 then inc(ind,6);
  ind:=ind+12*((move shr 8) and 255);
  inc(histtot[ind]);
  if histtot[ind]>=16384 then
  begin
    histtot[ind]:=(histtot[ind]+1) div 2;
    histhit[ind]:=(histhit[ind]+1) div 2;
  end;
end;

procedure PVToHash(score:integer;depth:byte;lin:TLine);
var i:integer;
    ply:byte;
    ind:longint;
begin
  if abs(score)+100>inf then exit;
  for i:=lin[0] downto 1 do
  begin
    ply:=lin[0]-i;
    ind:=abs(tree[ply].boardkey) mod HashSize;
    TransTable[ind].key:=tree[ply].boardkey;
    TransTable[ind].depth:=depth;
    TransTable[ind].age:=age;
    TransTable[ind].score:=score;
    TransTable[ind].move:=lin[i];
    TransTable[ind].flag:=2;
    if depth<>0 then dec(depth);
    score:=-score;
    makemove(lin[i],ply);
  end;
  for i:=1 to lin[0] do
  begin
    ply:=lin[0]-i;
    unmakemove(lin[i],ply);
  end;
end;

end.
