unit uci;

interface

uses sysutils{, windows}, fen, param, util, genmoves, movemake, tests, think, hash;

procedure gomain;

implementation

procedure gomain;
var str,cmd,sc,fn:string;
    mfrom,mto,b,p,i:integer;
    //handle,id,excode:cardinal;
    handle,id: TThreadId;
begin
  id:=0;
  while true do
  begin
    str:=input;
    (*
    if id<>0 then
    begin
      GetExitCodeThread(handle, excode);
      if excode = STILL_ACTIVE then Sleep(16)
      else id := 0;
    end;
    *)
    cmd:=SubStr(str,' ');

    if (uppercase(cmd)='QUIT') or (uppercase(cmd)='EXIT') then exit;

    if (uppercase(cmd)='UCI') then
    begin
      LPrint('id name '+Ver);
      LPrint('id author Ivan Maklyakov');
      LPrint('option name Hash type spin default 32 min 4 max 512');
      LPrint('option name Ponder type check default true');
      LPrint('option name Clear Hash type button');
      LPrint('uciok');
    end;

    if (uppercase(cmd)='ISREADY') then LPrint('readyok');

    if (uppercase(cmd)='UCINEWGAME') then
    begin
      readfen(startfen);
      clearhash;
    end;

    if (uppercase(cmd)='POSITION') then
    begin
      sc:=SubStr(str,' ');
      if uppercase(sc)='FEN' then
      begin
        fn:=SubStr(str,' ');
        fn:=fn+' '+SubStr(str,' ');
        fn:=fn+' '+SubStr(str,' ');
        fn:=fn+' '+SubStr(str,' ');
        fn:=fn+' '+SubStr(str,' ');
        fn:=fn+' '+SubStr(str,' ');
        ReadFen(fn);
      end;
      if uppercase(sc)='STARTPOS' then readfen(startfen);
      if str<>'' then sc:=SubStr(str,' ');
      while str<>'' do
      begin
        sc:=uppercase(SubStr(str,' '));
        mfrom:=((ord(sc[2])-ord('1')) shl 4) or (ord(sc[1])-ord('A'));
        mto:=((ord(sc[4])-ord('1')) shl 4) + (ord(sc[3])-ord('A'));
        movegen(0);
        b:=0; p:=0;
        if length(sc)=5 then
        begin
          if sc[5]='Q' then p:=2;
          if sc[5]='R' then p:=3;
          if sc[5]='B' then p:=4;
          if sc[5]='N' then p:=5;
        end;
        for i:=1 to tree[0].movenum do
          if moves[i] and ((255 shl 24) or (255 shl 8) or 255)=mfrom or (mto shl 8) or (p shl 24) then b:=i;
        if b=0 then halt;
        makemove(moves[b],0);
        copytree(1,0);
        if ((Board[(moves[b] shr 8) and 255] and 7)=6) or ((moves[b] shr 16)<>0) then rule50:=0;
        inc(rule50);
        ProvHash[Rule50]:=tree[0].boardkey;
      end;
    end;

    if (uppercase(cmd)='GO') then
    begin
      NewRule;
      while str<>'' do
      begin
        sc:=SubStr(str,' ');
        if lowercase(sc)='depth' then     Rules.depth:=strtoint(SubStr(str,' '));
        if lowercase(sc)='movetime' then  Rules.movetime:=strtoint(SubStr(str,' '));
        if lowercase(sc)='wtime' then     Rules.wtime:=strtoint(SubStr(str,' '));
        if lowercase(sc)='btime' then     Rules.btime:=strtoint(SubStr(str,' '));
        if lowercase(sc)='winc' then      Rules.winc:=strtoint(SubStr(str,' '));
        if lowercase(sc)='binc' then      Rules.binc:=strtoint(SubStr(str,' '));
        if lowercase(sc)='movestogo' then Rules.movestogo:=strtoint(SubStr(str,' '));
        if lowercase(sc)='mate' then      Rules.mate:=strtoint(SubStr(str,' '));
        if lowercase(sc)='infinite' then  Rules.infinite:=true;
        if lowercase(sc)='nodes' then     Rules.nodes:=strtoint(SubStr(str,' '));
        if lowercase(sc)='ponder' then    Rules.ponder:=true;
      end;
      //handle:=BeginThread(nil, 0, @Go, nil, 0, id);
      handle:=BeginThread(@Go, nil, id);
    end;

    if (uppercase(cmd)='SETOPTION') then
    begin
      sc:=SubStr(str,' ');
      sc:=SubStr(str,' ');
      if uppercase(sc)='HASH' then
      begin
        fn:=SubStr(str,' ');
        fn:=SubStr(str,' ');
        HashSizeMB:=strtoint(fn);
        inithash;
      end;
      if uppercase(sc)='PONDER' then
      begin
        fn:=SubStr(str,' ');
        fn:=SubStr(str,' ');
        if uppercase(fn)='TRUE' then ponder:=true;
        if uppercase(fn)='FALSE' then ponder:=false;
      end;
      if (uppercase(sc)='CLEAR') and (uppercase(str)='HASH') then ClearHash;
    end;

    if (uppercase(cmd)='PONDERHIT') then Rules.ponder:=false;

    if (uppercase(cmd)='STOP') then otmena:=true;

    if (uppercase(cmd)='TEST') and (id=0) then test2(6,startfen);
  end;

end;

end.
